<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2011 Thomas Dudzak <thomas@buergerbuero-borna.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   37: class tx_tdcalendar_pi1_listView extends tx_tdcalendar_pi1_library
 *   44:     function displayList()
 *   82:     function listTable($events)
 *
 * TOTAL FUNCTIONS: 2
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */
 class tx_tdcalendar_pi1_listView extends tx_tdcalendar_pi1_library {

  	/**
 * Diplay List Function: initialize upcoming list view of calendar and renders view
 *
 * @return	string		rendered list view
 */
	function displayList() {
		$this->fetchCurrValue('PIDeventDisplay', '0', 'sDEF', 1);
		$this->fetchCurrValue('listStartTime',time(), 'sDEF', 1);
		$this->fetchCurrValue('listEntryCount',5, 'sDEF', 1);
		$this->fetchCurrValue('PIDallEventsDisplay',0, 'sDEF', 1);

		$this->conf['showMultiDayOnlyOnce'] = 1;

		$this->listTemplateCode = $this->cObj->getSubpart($this->templateCode, '###LIST_VIEW###');
		$this->itemTemplateCode = $this->cObj->getSubpart($this->listTemplateCode, '###ITEM###');

		$markerArray = array();
		$subpartsArray = array();

		$markerArray['###VIEW_TITLE###'] = $this->pi_getLL('titleListView');
		$markerArray['###CATEGORY_TITLE###'] = $this->getCategorySelection();
		$entries = $this->getUpcomingEventsArray($this->conf['listStartTime']);

		$subpartsArray['###ITEM###'] = $this->listTable($entries);

		$markerArray['###ALL_EVENTS###'] = $this->conf['PIDallEventsDisplay'] ? $this->pi_linkTP($this->pi_getLL('allEvents'),Array(),$this->caching, $this->conf['PIDallEventsDisplay']) : '';

		$markerArray['###SUBMIT_EVENT###'] = ''; // That's where we will build the FE_Edit

		$out =  $this->cObj->substituteMarkerArrayCached($this->listTemplateCode, $markerArray, $subpartsArray, array());
		if ($this->conf['showTooltips'] == 1) {
			$out .= $this->tooltip;
		}

		return $out;
	}

	/**
	 * list Table function : rendering of upcoming list table
	 *
	 * @param	array		$events: array of calendar entries from DB
	 * @return	string		rendered upcoming list table
	 */
	function listTable($events) {
		$i = 0;
		foreach ($events as $event => $key) {
			if ($key['begin'] >= $this->conf['listStartTime']) {
				if($i == $this->conf['listEntryCount'])
					break;

				$markerArray['###TITLE###']  = $this->makeEventLink($key, $key['begin']);
				$markerArray['###DATE_BEGIN###'] = strftime($this->conf['dateFormat'],$key['begin']);
				$markerArray['###TIME_BEGIN###'] = strftime($this->conf['timeFormat'],$key['begin']);
				$markerArray['###CATEGORY###'] = $key['category'];
				$markerArray['###CATCOLOR###'] = $key['catcolor'];
				$markerArray['###ODD_EVEN###'] = $i%2==0 ? 'even' : 'odd';

				$markerArray['###READ_MORE###']  = $this->makeEventLink($key, $key['begin'],$this->pi_getLL('readMore'), 1);

				if($key['teaser']) {
					$markerArray['###TEASER###']  = $this->cObj->crop(strip_tags($key['teaser']), $this->conf['croppingLenght']);
				} else
					$markerArray['###TEASER###'] = $key['description'] ? $this->cObj->crop(strip_tags($key['description']), $this->conf['croppingLenght']):'';

				$content .= $this->cObj->substituteMarkerArrayCached($this->itemTemplateCode, $markerArray, $subpartsArray, array());

				$i++;
			}
		}

		return $content;
	}

 }

 if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/td_calendar/pi1/class.tx_tdcalendar_pi1_listView.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/td_calendar/pi1/class.tx_tdcalendar_pi1_listView.php']);
}

 ?>